blob: 5edab32a406b81080cdf1b9e9f34f8a68022d9e5 [file] [log] [blame]
Scott Baker2c1c4822019-10-16 11:02:41 -07001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
17# set default shell
18SHELL = bash -e -o pipefail
19
20# Variables
21VERSION ?= $(shell cat ./VERSION)
22
23# Default is GO111MODULE=auto, which will refuse to use go mod if running
24# go less than 1.13.0 and this repository is checked out in GOPATH. For now,
25# force module usage. This affects commands executed from this Makefile, but
26# not the environment inside the Docker build (which does not build from
27# inside a GOPATH).
28export GO111MODULE=on
29
30.PHONY: local-protos
31
32# This should to be the first and default target in this Makefile
33help:
34 @echo "Usage: make [<target>]"
35 @echo "where available targets are:"
36 @echo
37 @echo "build : Build the library"
38 @echo "clean : Remove files created by the build"
39 @echo "distclean : Remove build and testing artifacts and reports"
40 @echo "lint-style : Verify code is properly gofmt-ed"
41 @echo "lint-sanity : Verify that 'go vet' doesn't report any issues"
42 @echo "lint-mod : Verify the integrity of the 'mod' files"
43 @echo "lint : Shorthand for lint-style & lint-sanity"
44 @echo "mod-update : Update go.mod and the vendor directory"
45 @echo "test : Generate reports for all go tests"
46 @echo
47
48## Local Development Helpers
49local-protos:
50 @mkdir -p python/local_imports
51ifdef LOCAL_PROTOS
Scott Bakerf1b096c2019-11-01 12:36:30 -070052 rm -rf vendor/github.com/opencord/voltha-protos
53 mkdir -p vendor/github.com/opencord/voltha-protos/v2/go
54 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v2/go
Scott Baker2c1c4822019-10-16 11:02:41 -070055 rm -rf python/local_imports/voltha-protos
56 mkdir -p python/local_imports/voltha-protos/dist
Scott Bakerf1b096c2019-11-01 12:36:30 -070057 cp ${LOCAL_PROTOS}/dist/*.tar.gz python/local_imports/voltha-protos/dist/
Scott Baker2c1c4822019-10-16 11:02:41 -070058endif
59
60## build the library
Scott Bakerf1b096c2019-11-01 12:36:30 -070061build: local-protos
Scott Baker2c1c4822019-10-16 11:02:41 -070062 go build -mod=vendor ./...
63
64## lint and unit tests
65
66lint-style:
67ifeq (,$(shell which gofmt))
68 go get -u github.com/golang/go/src/cmd/gofmt
69endif
70 @echo "Running style check..."
71 @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
72 if [ ! -z "$$gofmt_out" ]; then \
73 echo "$$gofmt_out" ;\
74 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
75 exit 1 ;\
76 fi
77 @echo "Style check OK"
78
79lint-sanity:
80 @echo "Running sanity check..."
81 @go vet -mod=vendor ./...
82 @echo "Sanity check OK"
83
84lint-mod:
85 @echo "Running dependency check..."
86 @go mod verify
Scott Bakera36b4982019-11-26 08:09:23 -080087 @echo "Dependency check OK. Running vendor check..."
88 @git status > /dev/null
89 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
90 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
91 go mod tidy
92 go mod vendor
93 @git status > /dev/null
94 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
95 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
96 @echo "Vendor check OK."
Scott Baker2c1c4822019-10-16 11:02:41 -070097
98lint: lint-style lint-sanity lint-mod
99
100# Rules to automatically install golangci-lint
101GOLANGCI_LINT_TOOL?=$(shell which golangci-lint)
102ifeq (,$(GOLANGCI_LINT_TOOL))
103GOLANGCI_LINT_TOOL=$(GOPATH)/bin/golangci-lint
104golangci_lint_tool_install:
105 # Same version as installed by Jenkins ci-management
106 # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint
107 curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(GOPATH)/bin v1.17.0
108else
109golangci_lint_tool_install:
110endif
111
112# Rules to automatically install go-junit-report
113GO_JUNIT_REPORT?=$(shell which go-junit-report)
114ifeq (,$(GO_JUNIT_REPORT))
115GO_JUNIT_REPORT=$(GOPATH)/bin/go-junit-report
116go_junit_install:
117 go get -u github.com/jstemmer/go-junit-report
118else
119go_junit_install:
120endif
121
122# Rules to automatically install gocover-covertura
123GOCOVER_COBERTURA?=$(shell which gocover-cobertura)
124ifeq (,$(GOCOVER_COBERTURA))
125 @GOCOVER_COBERTURA=$(GOPATH)/bin/gocover-cobertura
126gocover_cobertura_install:
127 go get -u github.com/t-yuki/gocover-cobertura
128else
129gocover_cobertura_install:
130endif
131
132sca: golangci_lint_tool_install
133 rm -rf ./sca-report
134 @mkdir -p ./sca-report
135 $(GOLANGCI_LINT_TOOL) run --out-format junit-xml ./... 2>&1 | tee ./sca-report/sca-report.xml
136
137test: go_junit_install gocover_cobertura_install
138 @mkdir -p ./tests/results
139 @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
140 RETURN=$$? ;\
141 $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
142 $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
143 exit $$RETURN
144
145clean:
146
147distclean: clean
148 rm -rf ./sca_report ./tests
149
150mod-update: build
151 go mod tidy
152 go mod vendor
153
154# end file